"""HackTJ2020 URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.contrib import admin
from django.urls import include, path

from api import urls as api_urls
from frontend import urls as frontend_urls
from frontend.views import landing_page

urlpatterns = [
    path("", landing_page, name='landing_page'),
    path("admin/", admin.site.urls),
    path("api/", include(api_urls)),
    path("out/", include(frontend_urls)),
]
